// ZHLDemo_ApiDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ZHLDemo_Api.h"
#include "ZHLDemo_ApiDlg.h"
#include "Interface.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZHLDemo_ApiDlg dialog

CZHLDemo_ApiDlg::CZHLDemo_ApiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CZHLDemo_ApiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZHLDemo_ApiDlg)
	m_funcwh = -1;
	m_buf = -1;
	m_storeid = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CZHLDemo_ApiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZHLDemo_ApiDlg)
	DDX_Control(pDX, IDC_IMG, m_picture);
	DDX_CBIndex(pDX, combox_function, m_funcwh);
	DDX_CBIndex(pDX, combox_buf, m_buf);
	DDX_Text(pDX, IDC_EDIT3, m_storeid);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CZHLDemo_ApiDlg, CDialog)
	//{{AFX_MSG_MAP(CZHLDemo_ApiDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTNLL, OnBtnll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZHLDemo_ApiDlg message handlers

BOOL CZHLDemo_ApiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CZHLDemo_ApiDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CZHLDemo_ApiDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CZHLDemo_ApiDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CZHLDemo_ApiDlg::OnBtnll() 
{
	// TODO: Add your control notification handler code here
	UpdateData();  
	showfunction(m_funcwh);
	
}
void CZHLDemo_ApiDlg::showfunction(int wh)
{
	switch(wh)
	{
	case 0:
		show_FPVersion();
		break;
	case 1:
		show_SetAllvariable();
		break;
	case 2:
		show_GetAllvariable();
		break;
	case 3:
		show_InitDevice();
		break;
	case 4:
		show_CloseDevice();
		break;
	case 5:
		show_IsHaveFinger();
		break;
	case 6:
		show_UpImage();
		break;
	case 7:
		show_GetFpchar();
		break;
	case 8:
		show_GetFpMoudle();
		break;
	case 9:
		show_FpStore();
		break;
	case 10:
		show_FpMatch();
		break;
	case 11: 
		show_FpSearch();
		break;
	case 12:
		show_FpDelete();
		break;
	case 13:
		show_FpEmpty();
		break;
	case 14:
		show_Loadchar();
		break;
	case 15:
		show_Upchar();
		break;
	case 16:
		show_Downchar();
		break;
	case 17:
		show_Set_BaudLevel();
		break;
	default:
		AfxMessageBox("Choose test functions");
		break;
	}
 
}

void CZHLDemo_ApiDlg::show_FPVersion()
{
	char p_vers[256];
	int ret = FPVersion(p_vers);
	CString sresult = p_vers;

	CString temp = "";
	CString showstr = "";
	temp =  "Get version Function call routines:\r\n";
	temp +=  "\r\n";
	temp += " char p_vers[256];\r\n";
	temp += " int ret = FPVersion(p_vers);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:\r\n";
	temp += " ret = %d		//(0=Success, nonezero=failure)\r\n";
	temp += " p_vers = \"" + sresult +"\"";

	showstr.Format(temp,ret);

	SetDlgItemText(IDC_EDIT1,showstr);

}

void CZHLDemo_ApiDlg::show_SetAllvariable()
{	
	int variable[256];
	variable[0] = 1;	//0 Device(0,1,2,3,4,...)
	variable[1] = 256;	//1 Image width
	variable[2] = 288;	//2 Image height
	variable[3] = 512;	//3 Characteristic length
	variable[4] = 2;	//4 Number of registered fingerprints
	variable[5] = 0;	//5 Operating handle
	variable[6] = 1;	//6 Device type(0:Serial  1:usb  2:Other)
	variable[7] = 1;	//7 Serial number
	variable[8] = 115200;	//8 Baud rate

	int ret = SetAllvariable(variable);
 

	CString temp = "";
	CString showstr = "";
	temp =  "Reset to default  function call routines:\r\n";
	temp +=  "\r\n";
	temp += " int variable[256];\r\n";

	temp += " variable[0] = 1;  //Device(0,1,2,3,4,...)\r\n";
	temp += " variable[1] = 256;//Image width\r\n";
	temp += " variable[2] = 288;//Image height\r\n";
	temp += " variable[3] = 512;//Characteristic length\r\n";
	temp += " variable[4] = 2;	//Number of registered fingerprints\r\n";
	temp += " variable[5] = 0;	//Operating handle\r\n";
	temp += " variable[6] = 1;	//Device type(0:Serial  1:usb  2:Other)\r\n";
	temp += " variable[7] = 1;	//Serial number\r\n";
	temp += " variable[8] = 115200;	//Baud rate\r\n";
 

	temp += " int ret = SetAllvariable(variable);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:\r\n";
	temp += " ret = %d		//(0=Success, nonezero=failure)\r\n"; 

	showstr.Format(temp,ret);

	SetDlgItemText(IDC_EDIT1,showstr);
 
}

void CZHLDemo_ApiDlg::show_GetAllvariable()
{
	int variable[256]; 
	
	int ret = GetAllvariable(variable);
 
	CString temp = "";
	CString showstr = "";
	temp =  "Get all the parameters function call routines:\r\n";
	temp +=  "\r\n";
	temp += " int variable[256];\r\n"; 
	temp += " int ret = GetAllvariable(variable);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:\r\n";
	temp += " ret = %d		//(0=Success, nonezero=failure)\r\n"; 
	temp += " variable[0] =  %d;  //Device(0,1,2,3,4,...)\r\n";
	temp += " variable[1] =  %d;//Image width\r\n";
	temp += " variable[2] =  %d;//Image height\r\n";
	temp += " variable[3] =  %d;//Characteristic length\r\n";
	temp += " variable[4] =  %d;	//Number of registered fingerprints\r\n";
	temp += " variable[5] =  %d;	//Operating handle\r\n";
	temp += " variable[6] =  %d;	//Device type(0:Serial  1:usb  2:Other)\r\n";
	temp += " variable[7] =  %d;	//Serial number\r\n";
	temp += " variable[8] =  %d;	//Baud rate\r\n";
	showstr.Format(temp,ret,variable[0],variable[1],variable[2],variable[3],variable[4],
					variable[5],variable[6],variable[7],variable[8]);

	SetDlgItemText(IDC_EDIT1,showstr);
}

void CZHLDemo_ApiDlg::show_InitDevice()
{ 
	int ret = InitDevice(); 
	
	CString temp = "";
	CString showstr = "";
	temp =  "Reset to default function call routines:\r\n";
	temp +=  "\r\n"; 
	temp += " int ret = InitDevice();\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:\r\n";
	temp += " ret = %d		//(0=Success, nonezero=failure)\r\n"; 
	
	showstr.Format(temp,ret);
	
	SetDlgItemText(IDC_EDIT1,showstr);	
}

void CZHLDemo_ApiDlg::show_CloseDevice()
{
	int ret = CloseDevice(); 
	
	CString temp = "";
	CString showstr = "";
	temp =  "Close device function call routines:\r\n";
	temp +=  "\r\n"; 
	temp += " int ret = CloseDevice();\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:\r\n";
	temp += " ret = %d		//(0=Success, nonezero=failure)\r\n"; 
	
	showstr.Format(temp,ret);
	
	SetDlgItemText(IDC_EDIT1,showstr);		
}

void CZHLDemo_ApiDlg::show_IsHaveFinger()
{
	clock_t start,finish;
	start=clock();
	int ret = IsHaveFinger(); 
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Detect fingerprint function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " int ret = IsHaveFinger();\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d		//(0=Success, 2=Fingerprint not exist  Other=failure)\r\n"; 
	
	showstr.Format(temp,usetime,ret);
	
	SetDlgItemText(IDC_EDIT1,showstr);	
}

void CZHLDemo_ApiDlg::show_GetFpchar()
{
	clock_t start,finish;
	if(m_buf == -1){
		AfxMessageBox("Choose the characteristics of the buffer");
		return;
	}
	int buf = m_buf+1;
	start=clock();
	int ret = GetFpchar(buf); 
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Detect fingerprint function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " int buf = m_buf+1;//m_buf=0 or 1\r\n"; 
	temp +=  " int ret = GetFpchar(%d);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d		//(0=Success, Other=failure)\r\n"; 
	
	showstr.Format(temp,buf,usetime,ret);
	
	SetDlgItemText(IDC_EDIT1,showstr);	
}

void CZHLDemo_ApiDlg::show_GetFpMoudle()
{
	clock_t start,finish; 
	start=clock();
	int ret = GetFpMoudle(); 
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Detect fingerprint function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " int ret = GetFpMoudle();\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d		//(0=Success, Other=failure)\r\n"; 
	
	showstr.Format(temp,usetime,ret);
	
	SetDlgItemText(IDC_EDIT1,showstr);	
}

void  ShowImage(LPVOID lpParam,char *filename, int num, int count);
void CZHLDemo_ApiDlg::show_UpImage()
{
	clock_t start,finish; 
	start=clock();
	unsigned char ImgData [256*288];
	int ImgLen = 0;
	int ret = UpImage(ImgData,&ImgLen);
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Upload image function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " unsigned char ImgData [256*288];\r\n";
	temp +=  " int ImgLen = 0;\r\n"; 
	temp +=  " int ret = UpImage(ImgData,&ImgLen);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d		//(0=Success, Other=failure)\r\n"; 
	
	showstr.Format(temp,usetime,ret);
	if(ret == 0)
	{
		char *m_imgFile;
		m_imgFile = "c:\\Fp.bmp";
		WriteBmpFile(m_imgFile,ImgData,256,288);
		ShowImage((LPVOID)this,m_imgFile,2,1); 
	} 
	SetDlgItemText(IDC_EDIT1,showstr);	
 
}
 
void  ShowImage(LPVOID lpParam,char *filename, int num, int count)
{
	CZHLDemo_ApiDlg *pDlg = (CZHLDemo_ApiDlg*)lpParam; 
	HBITMAP hBitmapFP;
	hBitmapFP = (HBITMAP)LoadImage( GetModuleHandle(NULL),(LPCTSTR)filename, IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);
	if (hBitmapFP==NULL)
		hBitmapFP  = (HBITMAP)LoadImage( NULL,(LPCTSTR)filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	
	//Get the window size
	CRect r;
	pDlg->m_picture.GetClientRect(&r);
	CDC* pDC;
	if(count==1)
	{	pDC = pDlg->m_picture.GetDC();			}
	// 	else if(count==2)
	// 	{	 pDC = m_picture2.GetDC();			}
	// 	else if(count==3)
	// 	{	 pDC = m_picture3.GetDC();			}
	// Fill background
	pDC->FillRect(&r,NULL);
	//Select the bitmap into equipment in the scene
	CBitmap   cbmp;   
	cbmp.Attach(hBitmapFP);  
	//	CBitmap cbmp;
	//	cbmp.LoadBitmap(IDB_BITMAP1);
	CDC memdc;
	memdc.CreateCompatibleDC(pDC);
	memdc.SelectObject(&cbmp);
	
	//Get the bitmap parameter
	long width,height;
	BITMAP bmp;
	cbmp.GetBitmap(&bmp);
	width = bmp.bmWidth;
	height = bmp.bmHeight;
	//Start scaling
	
	switch(num)
	{
	case 0://50% display
		pDC->StretchBlt(r.left,r.top,(int)(width*0.5),(int)(height*0.5),&memdc,0,0,
			bmp.bmWidth,bmp.bmHeight,SRCCOPY);
		break;
	case 1://75% display
		pDC->StretchBlt(r.left,r.top,(int)(width*0.75),(int)(height*0.75),&memdc,0,0,
			bmp.bmWidth,bmp.bmHeight,SRCCOPY);
		break;
	case 2://100% display
		pDC->SetStretchBltMode(HALFTONE);//Ensure no distortion after scaling
		pDC->StretchBlt(r.left,r.top,r.right - r.left,r.bottom - r.top,&memdc,0,0,
			bmp.bmWidth,bmp.bmHeight,SRCCOPY);
		//	pDC->BitBlt(r.left,r.top, r.right - r.left,r.bottom - r.top,&memdc,0,0,SRCCOPY);
		//pDC->BitBlt(r.left,r.top,r.Width(),r.Height(),&memdc,0,0,SRCCOPY);
		break;
	case 3://150% display
		pDC->StretchBlt(r.left,r.top,(int)(width*1.5),(int)(height*1.5),&memdc,0,0,
			bmp.bmWidth,bmp.bmHeight,SRCCOPY);
		break;
	case 4:// Full size of the window
		pDC->StretchBlt(r.left,r.top,r.Width(),r.Height(),&memdc,0,0,
			bmp.bmWidth,bmp.bmHeight,SRCCOPY);
		break;
	}
	pDlg->m_picture.UpdateWindow();
	
	
	DeleteObject(hBitmapFP);
}
 

void CZHLDemo_ApiDlg::show_FpStore()
{
	clock_t start,finish; 
	start=clock(); 
	int storeid = m_storeid;
	int ret = FpStore(storeid); 
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Detect fingerprint function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " int storeid = 1;\r\n";
	temp +=  " int ret = FpStore(storeid);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d		//(0=Success, Other=failure)\r\n"; 
	
	showstr.Format(temp,usetime,ret);
	
	SetDlgItemText(IDC_EDIT1,showstr);	
}

void CZHLDemo_ApiDlg::show_FpMatch()
{
	clock_t start,finish; 
	start=clock(); 
	int iScore = 0;
	int ret = FpMatch(&iScore); 
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Detect fingerprint function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " int iScore = 0;\r\n";
	temp +=  " int ret = FpMatch(&iScore);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d, iScore = %d		//(0=Success, Other=failure)\r\n"; 
	
	showstr.Format(temp,usetime,ret,iScore);
	
	SetDlgItemText(IDC_EDIT1,showstr);	
}


void CZHLDemo_ApiDlg::show_FpSearch()
{
	clock_t start,finish; 
	start=clock(); 
	int iID = -1;
	int iScore = 0;
	int ret = FpSearch(&iID,&iScore); 
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Detect fingerprint function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " int iID = -1;\r\n"; 
	temp +=  " int iScore = 0;\r\n";
	temp +=  " int ret = FpSearch(&iID,&iScore);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d, iID = %d , iScore = %d		//(0=Success, Other=failure)\r\n";  
	showstr.Format(temp,usetime,ret,iID,iScore);
	
	SetDlgItemText(IDC_EDIT1,showstr);	
}


void CZHLDemo_ApiDlg::show_FpDelete()
{
	clock_t start,finish; 
	start=clock();  
	int storeid = m_storeid;
	int ret = FpDelete(storeid); 
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Detect fingerprint function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " int iScore = m_storeid;\r\n"; 
	temp +=  " int iScore = 0;\r\n";
	temp +=  " int ret = FpDelete(storeid);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d, storeid = %d  	//(0=Success, Other=failure)\r\n";  
	showstr.Format(temp,usetime,ret,storeid);
	
	SetDlgItemText(IDC_EDIT1,showstr);	
}

void CZHLDemo_ApiDlg::show_FpEmpty()
{
	clock_t start,finish; 
	start=clock();  
	int storeid = m_storeid;
	int ret = FpEmpty(); 
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Detect fingerprint function call routines:\r\n"; 
	temp +=  "\r\n";  
	temp +=  " int ret = FpEmpty();\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d 	//(0=Success, Other=failure)\r\n";  
	showstr.Format(temp,usetime,ret);
	
	SetDlgItemText(IDC_EDIT1,showstr);	
}

void CZHLDemo_ApiDlg::show_Loadchar()
{
	clock_t start,finish; 
	start=clock();  
	int loadid = m_storeid;
	int ret = Loadchar(loadid); 
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Detect fingerprint function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " int loadid = m_storeid;\r\n";  
	temp +=  " int ret = Loadchar(loadid);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d  	//(0=Success, Other=failure)\r\n";  
	showstr.Format(temp,usetime,ret);
	
	SetDlgItemText(IDC_EDIT1,showstr);
}
 
void CZHLDemo_ApiDlg::show_Upchar()
{
	clock_t start,finish; 
	start=clock();
	unsigned char fpchar [512];
	int ImgLen = 0;
	int ret = Upchar(fpchar);
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Upload characteristic function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " unsigned char fpchar [512];\r\n"; 
	temp +=  " int ret = Upchar(fpchar);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d		//(0=Success, Other=failure)\r\n"; 
	showstr.Format(temp,usetime,ret);
	
	SetDlgItemText(IDC_EDIT1,showstr);
 
}

void CZHLDemo_ApiDlg::show_Downchar()
{
	clock_t start,finish; 
	start=clock();
	unsigned char fpchar [512]; 
	int i = 0;
	for(i=0;i<512;i++)fpchar[i] = i;
	int ret = Downchar(fpchar);
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Download characteristic function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " unsigned char fpchar [512];\r\n"; 
	temp +=  " int i = 0;\r\n"; 
	temp +=  " for(i=0;i<512;i++)fpchar[i] = i;\r\n"; 
	temp +=  " int ret = Downchar(fpchar);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d		//(0=Success, Other=failure)\r\n"; 
	showstr.Format(temp,usetime,ret);
	
	SetDlgItemText(IDC_EDIT1,showstr);
}

void CZHLDemo_ApiDlg::show_Set_BaudLevel()
{
	clock_t start,finish; 
	start=clock(); 
	int nBaud = 115200;
	int nLevel = 3; 
	int ret = Set_BaudLevel(nBaud,nLevel);
	finish=clock();
	long usetime = finish-start;
	CString temp = "";
	CString showstr = "";
	temp =  "Set the baud rate level function call routines:\r\n"; 
	temp +=  "\r\n"; 
	temp +=  " int nBaud = 115200;\r\n"; 
	temp +=  " int nLevel = 3;\r\n";  
	temp +=  " int ret = Set_BaudLevel(nBaud,nLevel);\r\n";
	temp +=  "\r\n";
	temp +=  "Output result:(time-consuming:%dms)\r\n";
	temp += " ret = %d		//(0=Success, Other=failure)\r\n"; 
	showstr.Format(temp,usetime,ret);
	
	SetDlgItemText(IDC_EDIT1,showstr);
}